C @(#)radcnv.for	19.1.1.1 (ESO-DMD) 02/25/03 13:19:48
C===========================================================================
C Copyright (C) 1995 European Southern Observatory (ESO)
C
C This program is free software; you can redistribute it and/or 
C modify it under the terms of the GNU General Public License as 
C published by the Free Software Foundation; either version 2 of 
C the License, or (at your option) any later version.
C
C This program is distributed in the hope that it will be useful,
C but WITHOUT ANY WARRANTY; without even the implied warranty of
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C GNU General Public License for more details.
C
C You should have received a copy of the GNU General Public 
C License along with this program; if not, write to the Free 
C Software Foundation, Inc., 675 Massachusetts Ave, Cambridge, 
C MA 02139, USA.
C
C Correspondence concerning ESO-MIDAS should be addressed as follows:
C	Internet e-mail: midas@eso.org
C	Postal address: European Southern Observatory
C			Data Management Division 
C			Karl-Schwarzschild-Strasse 2
C			D 85748 Garching bei Muenchen 
C			GERMANY
C===========================================================================
C
      PROGRAM RADCNV
C 
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C.COPYRIGHT:      Copyright (c) 1987 European Southern Observatory,
C                                         all rights reserved
C.IDENTIFICATION: RADCNV
C.PURPOSE:        compute the size of an aperture in screen coordinates
C.AUTHOR:         Ch. Ounnas                  ESO - Garching
C.LANGUAGE:       F77+ESO      ext
C.KEYWORDS:       display
C.INPUT/OUTPUT:   the procedure file should contain:
C                 INPUTR/R/1/1                 radius of the aperture
C                 AP/I/1/4   local keyword to store screen pixels
C.VERSION:        871216  RHW  ESO-FORTRAN Conversion
C
C 021023	last modif
C 
C -------------------------------------------------------------------
C 
      IMPLICIT    NONE
C
      INTEGER     NPIX(2), XY(4),KUNI(1),KNUL,IMNO
      INTEGER     DSPSIZ(2),STAT,IAV
C
      CHARACTER   FRAME*80
C
      REAL        RINF(6),PIXEL1(6),PIXEL2(6),RS, RAYON
C
      DOUBLE PRECISION  START(2), STEP(2)
C
      INCLUDE     'MID_INCLUDE:ST_DEF.INC'
C
      INCLUDE     'MID_INCLUDE:IDIMEM.INC/NOLIST'
      INCLUDE     'MID_INCLUDE:IDIDEV.INC/NOLIST'
C
      INCLUDE     'MID_INCLUDE:ST_DAT.INC'
C
C ***
C
      CALL STSPRO('RADCNV')                         !get into MIDAS environment
      CALL DTOPEN(1,STAT)                           !open image display
C
C *** get the radius of the aperture in user unit
      CALL STKRDR('INPUTR',1,1,IAV,RAYON,KUNI,KNUL,STAT)
C
      CALL DTGICH(QDSPNO,QIMCH,FRAME,RINF,STAT)
      IF (SOURCE.NE.1)                               !no image loaded...
     +   CALL STETER(1,'RADCNV: No image loaded - we abort... ')
C
C *** get necessary descriptors of frame
      CALL STFOPN(FRAME,D_OLD_FORMAT,0,F_IMA_TYPE,IMNO,STAT)
      CALL STDRDI(IMNO,'NPIX',1,2,IAV,NPIX,KUNI,KNUL,STAT)
      CALL STDRDD(IMNO,'START',1,2,IAV,START,KUNI,KNUL,STAT)
      CALL STDRDD(IMNO,'STEP',1,2,IAV,STEP,KUNI,KNUL,STAT)
C
C *** now convert 2 pairs of world coordinates to screen pixels
      CALL PIXXCV('INIT',IMNO,RINF,STAT)
      PIXEL1(1) = START(1)
      PIXEL1(2) = START(2)
      CALL PIXXCV('WRS',IMNO,PIXEL1,STAT)
      IF (STAT.NE.0) CALL STETER(11,
     +   'RADCNV: Problem with conversion of start coord!')
C 
      RAYON = ABS(RAYON)
      IF (STEP(1).GT.0.) THEN
         PIXEL2(1) = PIXEL1(1) + RAYON
      ELSE
         PIXEL2(1) = PIXEL1(1) - RAYON
      END IF
      PIXEL2(2) = START(2)
      CALL PIXXCV('WRS',IMNO,PIXEL2,STAT)
      IF (STAT.NE.0) CALL STETER(11,
     +   'RADCNV: Problem with conversion of offset coord!')
C 
C calculate size of cursor rectangle
      RS = ABS(PIXEL2(5)-PIXEL1(5))
      XY(1) = 200
      XY(2) = 200
      XY(3) = 200 + IFIX(2.*RS) + 1
      XY(4) = 200 + IFIX(2.*RS) + 1
C 
C and check rectangle against display size (= IDIDEV(2,3))
      CALL STKRDI('IDIDEV',2,2,IAV,DSPSIZ,KUNI,KNUL,STAT)   !size of display
      IF ((XY(3) .GT. DSPSIZ(1)).OR.(XY(4) .GT. DSPSIZ(2))) THEN
         CALL STTPUT
     +   ('Radius too large - adjust rectangle size manually...',STAT)
         XY(3) = 250
         XY(4) = 250
      ENDIF
      CALL STKWRI('AP',XY,1,4,KUNI,STAT)
C
      CALL DTCLOS(QDSPNO)
      CALL STSEPI
      END

