! @(#)verify13.prg	19.1.1.1 (ESO-DMD) 02/25/03 14:34:53 
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!  MIDAS procedure verify13.prg  to verify MIDAS commands
!  K. Banse     030122
!
!  use as @@ verify13 ffffffffff             with f = 1 or 0 (on/off)
!
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 111111100000 n "Enter control flags for entries: "
!
define/local loop/i/1/1 0
define/local rval/r/1/1 0. ? +lower
define/local ival/i/1/5 0 all +lower
define/local seconds/i/1/2 0,0 ? +lower
define/local rcorr/r/1/20 0. all +lower
define/local icorr/i/1/20 0 all +lower
define/local errsum/i/1/1 0 ? +lower
define/local secs/i/1/2 0,0 ? +lower
define/local myvals/i/1/6 0 all +lower
!
delete/temp                             !get rid of old temporary files
! 
write/key sizez/i/1/5 400,400,0,0,0
write/key dispyes/i/1/2 0,0
write/key stop/i/1/1 0
!
write/out +------------------------------------------+
write/out Start of procedure verify13.prg
write/out +------------------------------------------+
!
!
! if enabled, handle FITS working environment
!
set/midas newfil=?? >Null
if outputc(1:1) .eq. "F" then           !we're in true FITS environment
   inputi = m$len(mid$types)
   define/local imatype/c/1/{inputi} {mid$types(1:8)} ? +lower
   inputi = m$len(mid$types(9:))
   define/local tbltype/c/1/{inputi} {mid$types(9:)} ? +lower
   define/local workenv/c/1/4 FITS ? +lower
else
   define/local imatype/c/1/3 bdf ? +lower
   define/local tbltype/c/1/3 tbl ? +lower
   define/local workenv/c/1/5 Midas ? +lower
endif
! 
seconds(1) = m$secs()
set/format i1
do loop = 1 5
   if p1({loop}:{loop}) .eq. "1" @@ verify13,000{loop}
   if errsum .gt. 0 then
      write/out "We got problems with entry 000{loop} in verify13.prg!"
      stop = 1
      return
   endif
enddo
! 
seconds(2) = m$secs()
ival = seconds(2)-seconds(1)
!
write/out +------------------------------------------+
write/out procedure verify13.prg:
write/out Total time elapsed after first 9 tests = {ival} seconds.
!
! because of the clear/contetx command we loose all local keywords,
! therefore entry 10, 11, ... execution comes here...
! 
write/out All tests o.k. - you deserve a coffee now...
write/out +------------------------------------------+
! 
!  here the different sub-procedures
!
entry 0001
!
write/out test of CREATE/DISPLAY + CREATE/GRAPHICS
write/out "----------------------------------------"
!
reset/display
create/display 7 512,512,616,300
dispyes(1) = 1                          !mark that we have display + graphic
dispyes(2) = 1
display/lut off
!
entry 0002
!
write/out  test of missing CDELT in FITS header
write/out "-------------------------------------"
!
if workenv(1:1) .eq. "F" then
   -copy nocdelt.fits ctest.fits
else
   indisk/fits nocdelt.fits ctest.bdf >Null
endif
write/out > use 3-dim image ctest.{imatype} which has no CDELTi FITS keywords
read/descr ctest.{imatype}
if m$value(ctest.{imatype},step(1)) .gt. 0.99 then
   write/out > could not compute stepsize correctly...
   errsum = errsum + 1
   return
endif
! 
if dispyes(1) .eq. 1 then
   load/lut rainbow4 ? d
   load/image ctest.{imatype},2 scale=2
   draw/arrow @29,@59,@16,@70 f ? yellow >Null
endif
!
write/out 
write/out > convert/coord ctest.{imatype} @14,@72,@2
convert/coord ctest.{imatype} @14,@72,@2
write/key rcorr 3.5783772,-32.26596,2,0,14,18.81,-32,15,57.46,14,72,2
@@ kcompare rcorr outputd 1,12 0.0001
! 
write/out 
write/out > read/ima  ctest.bdf @14,@72,@2,4
read/ima  ctest.bdf @14,@72,@2,4
write/keyw rcorr 7464.000,6177.000,3283.000,3283.000
@@ kcompare rcorr outputr 1,4 0.001
write/out 
write/out > read/ima  ctest.bdf 0:14:18.81,-32:15:57.46,@2,4
read/ima  ctest.bdf 0:14:18.81,-32:15:57.46,@2,4
@@ kcompare rcorr outputr 1,4 0.0001
write/out 
write/out > data value at pixel ctest[0:14:18.81,-32:15:57.46,@2]:
write/out {ctest[0:14:18.81,-32:15:57.46,@2]}
inputr = {ctest[0:14:18.81,-32:15:57.46,@2]}
@@ kcompare rcorr inputr 1,1 0.0001
!
entry 0003
!
write/out test of pipeline messaging
write/out "--------------------------"
!
inputi(12) = 123
mess/out 3 klaus "this is a test of: \t\t {inputi(12)}"
append/out ulli  
mess/out 2 momo

mess/out 1 noman  "nochmal \x999  \n\tund weiter {inputi(12)}"

mess/out 3 lola "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbccddeeffgghhiijjkkllmmnnooppqqrrssttuuvvwwxxyyzz"


append/out 
append/out xxxxxxxxxxx
append/out \t
append/out cccccc
mess/out 1 koko " \t klaus"
!
entry 0004
!
! 
if workenv(1:1) .eq. "F" return
! 
! 
!
if workenv(1:1) .eq. "F" return
! 
!
entry 0005
!
!

